﻿namespace bo.Text;

interface

uses
  System.IO;

type
  // note the 'abstract': this eliminates the warning on the abstract CreateProcessor method
  BaseReencoder = public abstract class(BaseTextProcessor)
  public
    method CreateProcessor(): DefaultToDefaultProcessor; abstract;
    method Run(inputEncodingName: string; outputEncodingName: string); virtual;
    method Run(inputEncodingName: string; outputEncodingName: string; inputFileName: string); virtual;
    method Run(inputEncodingName: string; outputEncodingName: string; inputFileName: string; outputFileName: string); virtual;
    method Run(args: array of string); virtual;
    method Run(input: Stream; output: Stream); virtual;
    method Run(input: Stream; output: Stream; processor: DefaultToDefaultProcessor); virtual;
  end;
  
implementation

{$REGION Specific encodings}

method BaseReencoder.Run(inputEncodingName: string; outputEncodingName: string); 
begin
  //var specificToSpecificProcessor: SpecificToSpecificProcessor;
  //SpecificToSpecificProcessor := new SpecificToSpecificProcessor(inputEncodingName, outputEncodingName);
  //Run(Console.OpenStandardInput(), Console.OpenStandardOutput(), specificToSpecificProcessor);
end;

method BaseReencoder.Run(inputEncodingName: string; outputEncodingName: string; inputFileName: string);
begin
  //SpecificToSpecificProcessor specificToSpecificProcessor = new SpecificToSpecificProcessor(inputEncodingName, outputEncodingName);
  //using (Stream inputStream = GetInputStream(inputFileName))
  //begin
      //Run(inputStream, Console.OpenStandardOutput(), specificToSpecificProcessor);
  //end;
end;

method BaseReencoder.Run(inputEncodingName: string; outputEncodingName: string; inputFileName: string; outputFileName: string);
begin
  //SpecificToSpecificProcessor specificToSpecificProcessor = new SpecificToSpecificProcessor(inputEncodingName, outputEncodingName);
  //using (Stream inputStream = GetInputStream(inputFileName))
  //begin
      //using (Stream outputStream = GetOutputStream(outputFileName))
      //begin
          //Run(inputStream, outputStream, specificToSpecificProcessor);
      //end;
  //end;
end;

{$ENDREGION}

method BaseReencoder.Run(args: array of string);
begin
  var input: Stream;
  var output: Stream;

  if (args.Length > 0) then
    input := GetInputStream(args[0])
  else
    input := Console.OpenStandardInput();

  if (args.Length > 1) then
    output := GetOutputStream(args[1])
  else
    output := Console.OpenStandardOutput();

  try
    Run(input, output);
  finally
    if (args.Length > 1) then
      output.Close();
    if (args.Length > 0) then
      input.Close();
  end;
end;

method BaseReencoder.Run(input: Stream; output: Stream);
begin
  var processor := CreateProcessor();
  Run(input, output, processor);
end;

method BaseReencoder.Run(input: Stream; output: Stream; processor: DefaultToDefaultProcessor);
begin
  processor.Process(input, output);
end;

end.